#ifndef MOTOR_H
	#define MOTOR_H
#endif
#include "MotorDriver.h"
#include <stdlib.h>
#include <Arduino.h>

MotorDriver::MotorDriver(Motor *m1, Motor *m2) {
	_motor1 = m1;
	_motor2 = m2;
}

MotorDriver::~MotorDriver() {
	free(_motor1);
	free(_motor2);
}

void MotorDriver::forward(Motor *m) {
	digitalWrite(m->getPin1(), HIGH);
	digitalWrite(m->getPin2(), LOW);
}

void MotorDriver::backward(Motor *m) {
	digitalWrite(m->getPin1(), LOW);
	digitalWrite(m->getPin2(), HIGH);
}

void MotorDriver::stop(Motor *m) {
	digitalWrite(m->getPin1(), LOW);
	digitalWrite(m->getPin2(), LOW);
}

void MotorDriver::forward() {
	forward(_motor1);
	forward(_motor2);
}

void MotorDriver::backward() {
	backward(_motor1);
	backward(_motor2);
}

void MotorDriver::turnLeft() {
	backward(_motor1);
	forward(_motor2);
}

void MotorDriver::turnRight() {
	forward(_motor1);
	backward(_motor2);
}

void MotorDriver::stop() {
	stop(_motor1);
	stop(_motor2);
}
