//#ifndef SENSOR_H
//	#define SENSOR_H
//#endif
//
#include "Robot.h"
//#include <list>

Robot::Robot()
{
	//sensor = NULL;
}

Robot::~Robot()
{
	free(sensor);
	free(motorDriver);
}

void Robot::build() {
	UltrasonicSensor *s = new UltrasonicSensor(3, 2);
	this->setSensor(s);

	Motor *m1 = new Motor(6, 7);
	Motor *m2 = new Motor(4, 5);
	MotorDriver *md = new MotorDriver(m1, m2);
	this->setMotorDriver(md);

	this->setMinDistance(20);
}

//void Robot::addSensor(Sensor s) {
//	sensors->add(s);
//}
//
void Robot::setSensor(UltrasonicSensor *s) {
	sensor = s;
}
void Robot::setMotorDriver(MotorDriver *md) {
	motorDriver = md;
}

void Robot::setMinDistance(float d) {
	minDistance = d;
}

void Robot::setDelays(int main, int turn, int stop) {
	mainDelay = main;
	turnDelay = turn;
	stopDelay = stop;
}

bool Robot::mustTurn() {
	currentDistance = sensor->getDistance();
	return currentDistance <= minDistance;
}

float Robot::getCurrDistance() {
	return this->currentDistance;
}

void Robot::moveForward() {
	motorDriver->forward();
	delay(mainDelay);
}

void Robot::moveBackward() {
	motorDriver->backward();
	delay(mainDelay);
}

void Robot::turnLeft() {
	motorDriver->turnLeft();
	delay(turnDelay);
}

void Robot::turnRight() {
	motorDriver->turnRight();
	delay(turnDelay);
}

void Robot::stop() {
	motorDriver->stop();
	delay(stopDelay);
}
